/*
 * Copyright 2012 Smallcrew, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package fr.smallcrew.rest.wadl;

import fr.smallcrew.rest.data.wadl.Application;
import fr.smallcrew.rest.view.FailSafeViewResolver;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerMapping;

import javax.servlet.http.HttpServletRequest;

@Controller
@RequestMapping("/wadl")
public class WadlController {
  @Autowired
  private RequestMappingHandlerMapping handlerMapping;

  @Autowired
  private FailSafeViewResolver viewResolver;

  @RequestMapping(method = RequestMethod.GET)
  public Application get(HttpServletRequest request) {
    return ApplicationBuilder.from(request, handlerMapping, viewResolver.getMediaTypes()).build();
  }
}